#pragma once

#include <string>
#include <list>
#include <vector>

#include "GBStream.h"
#include "ConvertUTF.h"
#include "ConvertUTFUtil.h"
#include "INpMsgr.h"
#include "IkWnd.h"

using namespace std;

class CNpMsgrIPT : public INpMsgrIPT,
				   public _INpSessionDispatcher_PacketHandler	
{
public:
	CNpMsgrIPT();
	virtual ~CNpMsgrIPT();
	
	INpSessionDispatcher * m_pNpSD;

	virtual void CALLBACK IkWnd_OnMessage(CIkWnd * pIkWnd, UINT message, WPARAM wParam, LPARAM lParam );

///////////////////////////////////////////////////////////////////////////////////////
// INpMsgrBuddy
	
	virtual void __stdcall AdviseEvents(_INpMsgrIPTEvents * pEvents);			// support multiple event receiver
	virtual void __stdcall UnadviseEvents(_INpMsgrIPTEvents * pEvents);

	virtual void __stdcall InitModule(INpSessionDispatcher * pSD_MainServer);

protected:
	class CIPTQueryItem
	{
	public:
		CIPTQueryItem(int nTrId, USHORT usCMMD, LPCSTR pszSendData, int nSendDataLength, int nCallerTrId)
		{
			m_nSendDataLength = 0;
			m_nTrId = nTrId;
			m_nCallerTrId = nCallerTrId;
			m_usCMMD = usCMMD;
			m_pszSendData = new char[nSendDataLength];
			if (NULL != m_pszSendData)
			{
				memcpy( m_pszSendData, pszSendData, nSendDataLength );
				m_nSendDataLength = nSendDataLength;
			}
		}
		~CIPTQueryItem()
		{
			if (NULL != m_pszSendData) delete [] m_pszSendData;
		}

		int m_nTrId;
		int m_nCallerTrId;
		USHORT m_usCMMD;
		char * m_pszSendData;
		int m_nSendDataLength;
	};
	int SendQuery( USHORT usCMD, USHORT usBodyDataLen, LPCSTR szBodyData, int nCallerTrId = 0 );
	std::list<CIPTQueryItem*> m_listIPTQuery;

	virtual void CALLBACK INpSessionDispatcher_OnReceive_REQUEST_PACKET(INpSessionDispatcher * pEventSource, const INpPacket * pPacket);
	virtual void CALLBACK INpSessionDispatcher_OnReceive_RESPONSE_PACKET(INpSessionDispatcher * pEventSource, const INpPacket * pOriginalRequestPacket, const INpPacket * pPacket);

	std::vector<_INpMsgrIPTEvents*> m_vecEvents;

public:
	virtual bool __stdcall PhoneCall(LPCWSTR strUserID, LPCWSTR strPhoneNo, int nTrid = 0);
	virtual bool __stdcall AnswerCall(LPCWSTR strUserID, LPCWSTR strCID, int nTrid = 0);
	virtual bool __stdcall HangUp(LPCWSTR strUserID, LPCWSTR strCID, int nTrid = 0);
	virtual bool __stdcall CallForwarding(LPCWSTR strUserID, BYTE nMode, LPCWSTR strPhoneNo, int nTrid = 0);
	virtual bool __stdcall CallForwardingInfo( LPCWSTR strUserID, int nTrid = 0 );
	virtual bool __stdcall CallTransfer( LPCWSTR strUserID, LPCWSTR strTargetID, int nTrid = 0 );
	virtual bool __stdcall CallPickUp( LPCWSTR strUserID, LPCWSTR strTargetID, int nTrid = 0 );
	virtual bool __stdcall SetDND( LPCWSTR strUserID, BYTE nMode, int nTrid = 0 );
	virtual bool __stdcall PhoneStatus( LPCWSTR strUserID, vector<LPCWSTR> &vecUserID, int nTrid = 0 );
	virtual bool __stdcall ConferenceCall( LPCWSTR strUserID, LPCWSTR strPhoneNo, int nTrid = 0 );
	virtual bool __stdcall HoldCall( LPCWSTR strUserID, LPCWSTR strCID, int nTrid = 0 );
	virtual bool __stdcall ResumeCall( LPCWSTR strUserID, LPCWSTR strCID, int nTrid = 0 );
	virtual bool __stdcall DndStatusInfo( LPCWSTR strUserID, int nTrid = 0 );
};
